
CoCoALib - Bug #351

Problems with DenseMatImpl::myResize

21 May 2013 17:35 - Anna Maria Bigatti

Status: Closed Start date: 21 May 2013

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: Safety Estimated time: 3.00 hours

Target version: CoCoALib-0.99533 Easter14 Spent time: 2.75 hours

Description

When calling

  void DenseMatImpl::myResize(long NumRows, long NumCols)

for removing a row/colum the program runs OK, but on exit gives "IMMINENT DISASTER".

Maybe something is not freed properly? Code looks very reasonable.    

Needs proper investigation with valgrind, memleaks tools,..

Related issues:

Related to CoCoALib - Feature #373: add DeleteCol, DeleteRow Closed 17 Jun 2013

History

#1 - 17 Jun 2013 18:26 - Anna Maria Bigatti

- Status changed from New to Resolved

- Assignee set to Anna Maria Bigatti

- % Done changed from 0 to 90

fixed really subtle bug in myResize()

  myEntries[i].resize(NumCols, myR->myNew()); // second arg not used

second argument is not used, but myNew is called (and created a dangling element).

So now we actually create a useless RingElem, and pass raw(useless) instead.    

Not so horrible to find thanks to our wonderful memory debugger ;-)

[ERR] MemPoolDebug("RingDistrMPolyCleanImpl::myDMPPool") ERROR:  dtor, unfreed slices: NumSlices=3

ERROR!!!  RingQQ refcount = 4 but should be 1.

#2 - 29 Oct 2013 14:58 - Anna Maria Bigatti
- Target version changed from CoCoALib-0.99534 Seoul14 to CoCoALib-0.99532

#3 - 01 Apr 2014 18:09 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99532 to CoCoALib-0.99533 Easter14

#4 - 17 Apr 2014 00:40 - John Abbott

I guess you could use raw(zero(myR)) instead of raw(useless); though perhaps the latter is clearer?

#5 - 17 Apr 2014 08:24 - Anna Maria Bigatti

- Status changed from Resolved to Closed

- % Done changed from 90 to 100

- Estimated time set to 3.00 h

tested, added test-matrix4 (which indeed gave IMMINENT DISASTER before recompiling ;-)
